import { writable } from 'svelte/store';

function createMyStore() {
  const { subscribe, set, update } = writable(null);

  return {
    subscribe,
    update: (res_my, cb=null) => {
      if (res_my.status === 200) {
        res_my.json().then((my) => {
          for (let k in my.exercices) {
            my.exercices[k].id = k;

            if (my.exercices[k].flags) {
              let nb = 0;
              for (let j in my.exercices[k].flags) {
                if (!my.exercices[k].flags[j].found)
                  nb += 1;
              }
              my.exercices[k].non_found_flags = nb;
            }

            if (my.team_id === 0 && my.exercices[k].hints) {
              for (let j in my.exercices[k].hints) {
                my.exercices[k].hints[j].hidden = true;
              }
            }
          }

          update((m) => (Object.assign(m?m:{}, my)));

          if (cb) {
            cb(my);
          }
        });
      } else if (res_my.status === 404) {
        update((m) => (null));
      }
    },
  };
}

export const my = createMyStore();
