package main

import (
	"encoding/json"
	"os"
	"time"
)

func loadTS(tspath string) (timestamp map[AirbusUserId]time.Time, err error) {
	var fd *os.File
	if _, err = os.Stat(tspath); os.IsNotExist(err) {
		timestamp = map[AirbusUserId]time.Time{}
		err = saveTS(tspath, timestamp)
		return
	} else if fd, err = os.Open(tspath); err != nil {
		return nil, err
	} else {
		defer fd.Close()
		jdec := json.NewDecoder(fd)

		if err = jdec.Decode(&timestamp); err != nil {
			return
		}

		return
	}
}

func saveTS(tspath string, ts map[AirbusUserId]time.Time) error {
	if fd, err := os.Create(tspath); err != nil {
		return err
	} else {
		defer fd.Close()
		jenc := json.NewEncoder(fd)

		if err := jenc.Encode(ts); err != nil {
			return err
		}

		return nil
	}
}
